/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.stimmeingabe;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.stimmeingabe.boundary.AbstractStimmeingabePlausiKonfigurationSearchParameters;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationChangeEvent;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationConversationStore;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationExtendedDAO;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationSearch;
import de.ivu.elect.business.stimmeingabe.boundary.StimmeingabePlausiKonfigurationSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfiguration;
import de.ivu.elect.business.stimmeingabe.entity.StimmeingabePlausiKonfigurationMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStimmeingabePlausiKonfigurationSearchView.COMPONENT_NAME)
@View(viewId = AbstractStimmeingabePlausiKonfigurationSearchView.VIEW_ID, useCase = UseCasePermission.STIMMEINGABE_PLAUSI_SEARCH)
public abstract class AbstractStimmeingabePlausiKonfigurationSearchView extends AbstractElectSearchView<StimmeingabePlausiKonfiguration> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmeingabePlausiKonfigurationSearchView";
  
  public static final String VIEW_ID = "/stimmeingabe/stimmeingabe-plausi-konfiguration-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStimmeingabePlausiKonfigurationSearchView requestHandler;

  @Inject
  private transient StimmeingabePlausiKonfigurationExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StimmeingabePlausiKonfigurationConversationStore.class)
  protected transient StimmeingabePlausiKonfigurationConversationStore conversationStore;

  @Inject
  protected transient StimmeingabePlausiKonfigurationSearch search;

  @Inject
  @ConversationGroup(AbstractStimmeingabePlausiKonfigurationSearchParameters.class)
  protected transient StimmeingabePlausiKonfigurationSearchParameters searchParameters;

  @Inject
  protected transient StimmeingabePlausiKonfigurationMeta entityMeta;

  public AbstractStimmeingabePlausiKonfigurationSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public StimmeingabePlausiKonfiguration getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(StimmeingabePlausiKonfiguration entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StimmeingabePlausiKonfigurationSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<StimmeingabePlausiKonfiguration> getEagerLoadingCollector() {
    return EagerLoadingCollector.<StimmeingabePlausiKonfiguration> create();
  }

  @Override
  public List<StimmeingabePlausiKonfiguration> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<StimmeingabePlausiKonfiguration> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStimmeingabePlausiKonfigurationChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StimmeingabePlausiKonfigurationChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStimmeingabePlausiKonfigurationSearchView {

    @View
    @Inject
    private transient Instance<AbstractStimmeingabePlausiKonfigurationSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStimmeingabePlausiKonfigurationSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
